<template>
  <div class="container">
    <!-- 查询配置 -->
    <div style="padding: 0px 20px">
      <div ref="lxHeader">
        <LxHeader icon="md-apps" text="安全生产设施设备" style="margin-bottom: 10px; border: 0px; margin-top: 15px">
          <div slot="content"></div>
          <slot>
            <div>
              <Input style="width: 200px; margin-right: 10px" v-model="searchFields.KeyWord" placeholder="关键字搜索" />
              <Button type="primary" @click="load" style="margin-left: 10px">查询</Button>
              <Button type="primary" @click="edit()" style="margin-left: 10px">新增</Button>
            </div>
          </slot>
        </LxHeader>
      </div>
      <div ref="lxTable">
        <el-table :data="tableData" :height="tableHeight" style="width: 100%">
          <el-table-column type="index" width="50" align="center" fixed="left"> </el-table-column>
          <el-table-column :prop="column.field" :align="column.align" v-for="(column,index) in columns"
            :label="column.title" :width="column.width" :fixed="column.fixed">
            <template slot-scope="scope">
              <div v-if="column.type=='opt'">
                <Button ghost size="small" @click="edit(scope.row)" type="primary"
                  style="margin-left: 10px;">编辑</Button>
                <Button ghost size="small" @click="del(scope.row)" type="error" style="margin-left: 10px;">删除</Button>
              <Button ghost size="small" @click="editMain(scope.row)" type="primary"
                style="margin-left: 10px;">维保</Button>
              </div>
              <div v-else-if="column.type=='defect_type'">
                <div v-for="item in parameters.defectType">
                  <div v-if='scope.row[column.field]==item.id'>
                    {{item.value}}
                  </div>
                </div>

              </div>
              <div v-else-if="column.type=='format'">
                <div v-if="column.field=='admin'||column.field=='department'||column.field=='maintenance_department'">
                  {{scope.row[column.field]?scope.row[column.field].name:""}}
                </div>
              </div>
              <div v-else>{{scope.row[column.field]}}</div>
            </template>
          </el-table-column>
        </el-table>
        <div class="pagination">
          <el-pagination @current-change="handleCurrentChange" :current-page="paginations.page"
            :page-size="paginations.page_size" background layout="prev, pager, next" :total="paginations.total">
          </el-pagination>
        </div>
      </div>

    </div>

    <el-dialog title="安全生产设施设备编辑" :visible.sync="dialogFormVisible" width="90%">
      <div class="dialogConcent">
        <el-scrollbar style="flex: 1">
          <el-form :model="form" :rules="rules" ref="form" label-position="right" :label-width="formLabelWidth">
            <el-form-item label="设备(设施)名称" prop="name" class="units">
              <el-input v-model="form.name" placeholder="请填写设备(设施)名称" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="缺陷描述" prop="defect">
              <el-input type="textarea" :rows="3" v-model="form.defect" placeholder="请填写缺陷描述" autocomplete="off"></el-input>
            </el-form-item>
            <el-row>
              <el-col :span="8">
                <el-form-item label="发现人" prop="discover_person" label-position="right">
                  <el-input v-model="form.discover_person" placeholder="请填写发现人" autocomplete="off"></el-input>
                </el-form-item>
              </el-col>
              <el-col :span="8">
                <el-form-item label="发现时间" prop="discover_time" label-position="right">
                  <el-date-picker style="width:100%" type="date" v-model="form.discover_time" value-format="yyyy-MM-dd"
                   placeholder="发现时间">
                  </el-date-picker>
                </el-form-item>
              </el-col>
              <el-col :span="8">
                <el-form-item label="缺陷类别" prop="defect_type" label-position="right">
                  <el-select v-model="form.defect_type" placeholder="请选择缺陷类别" style="width: 100%">
                    <el-option v-for="item in parameters.defectType" :key="item.id" :label="item.value"
                      :value="item.id">
                    </el-option>
                  </el-select>
                </el-form-item>
              </el-col>
            </el-row>
            <el-row>
              <el-col :span="8">
                <el-form-item label="当前状态" prop="status" label-position="right">
                  <el-select v-model="form.status" placeholder="请选择当前状态" style="width: 100%">
                    <el-option v-for="item in parameters.equipmentStatus" :key="item.id" :label="item.value"
                      :value="item.id">
                    </el-option>
                  </el-select>
                </el-form-item>
              </el-col>
              <el-col :span="8">
                <el-form-item label="计划维保时间" prop="maintain_time" label-position="right">
                  <el-date-picker style="width:100%" type="date" v-model="form.maintain_time" value-format="yyyy-MM-dd"
                   placeholder="计划维保时间">
                  </el-date-picker>
                </el-form-item>
              </el-col>
            </el-row>
            <el-form-item label="备注" prop="remark">
              <el-input type="textarea" :rows="3" v-model="form.remark" placeholder="请填写备注" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="附件" prop="file_list">
              <el-upload class="upload-demo" :on-success="handlesuccess" :data="uploadOther"
                :action="action" :on-remove="handleRemove" :before-remove="beforeRemove"
                :on-exceed="handleExceed" :file-list="fileList">
                <el-button size="small" type="primary">点击上传</el-button>
              </el-upload>
            </el-form-item>
          </el-form>
        </el-scrollbar>
      </div>
      <div slot="footer" class="dialog-footer">
        <el-button @click="resetForm('form')">取 消</el-button>
        <el-button type="primary" v-preventReClick @click="submitForm('form')">确 定</el-button>
      </div>
    </el-dialog>
  <el-dialog title="安全生产设施设备维保编辑" :visible.sync="dialogMainFormVisible" width="60%">
      <div class="dialogConcent">
        <el-scrollbar style="flex: 1">
          <el-form :model="mainForm" :rules="mainrules" ref="mainForm" label-position="right" :label-width="formLabelWidth">
            <el-form-item label="维保人" prop="name" class="units">
              <el-input v-model="mainForm.maintain_name" placeholder="请填写维保人" autocomplete="off"></el-input>
            </el-form-item>
            <el-form-item label="维保完成时间" prop="discover_time" label-position="right">
              <el-date-picker style="width:100%" type="date" v-model="mainForm.finish_time" value-format="yyyy-MM-dd"
               placeholder="维保完成时间">
              </el-date-picker>
            </el-form-item>
            <el-form-item label="验收人" prop="accept_person" class="units">
              <el-input v-model="mainForm.accept_person" placeholder="请填写维保人" autocomplete="off"></el-input>
            </el-form-item>

            <el-form-item label="备注" prop="remark">
              <el-input type="textarea" :rows="3" v-model="mainForm.remark" placeholder="请填写备注" autocomplete="off"></el-input>
            </el-form-item>
          </el-form>
        </el-scrollbar>
      </div>
      <div slot="footer" class="dialog-footer">
        <el-button @click="resetForm('mainForm')">取 消</el-button>
        <el-button type="primary" v-preventReClick @click="submitMainForm('mainForm')">确 定</el-button>
      </div>
    </el-dialog>


  </div>
</template>

<script>
  import {
    getToken
  } from '@/utils/auth'
  import LxHeader from "@/components/LxHeader/index.vue";
  import Tinymce from '@/components/Tinymce'
  import {
    save,
    store,
    del,
    get,
    listtask,
    maintains
  } from "../../api/site/equipment.js";
  import {
    getparameteritem
  } from "../../api/system/dictionary.js";
  export default {
    components: {
      LxHeader,
      Tinymce
    },
    data() {
      return {      action:`${process.env.VUE_APP_BASE_API}api/admin/upload-file`,
        parameters: {
          defectType: [],
          equipmentStatus:[]
        },
        paginations: {
          page: 1,
          page_size: 15,
          total: 0
        },
        tableHeight: 0,
        dialogFormVisible: false,
        dialogMainFormVisible: false,
        formLabelWidth: "120px",
        clientHeight: 0,
        form: {
          name: "",
          defect: "",
          discover_person: "",
          discover_time: "",
          defect_type: "",
          status: "",
          maintain_time: "",
          remark: "",
          file_list: "",
        },
        mainForm:{
          maintain_name:"",
          finish_time:"",
          accept_person:"",
          remark:""

        },
        fileList: [],
        tableData: [],
        rules: {
          name: [{
            required: true,
            message: '请填写设施（设备）名称',
            trigger: 'blur'
          }],
          defect: [{
            message: '请填写缺陷描述',
            trigger: 'blur'
          }],
          discover_person: [{
            message: '请填写发现人',
            trigger: 'blur'
          }],
          discover_time: [{
            message: '请填写发现时间',
            trigger: 'blur'
          }],
          defect_type: [{
            type:'number',
            message: '请选择缺陷类别',
            trigger: 'blur'
          }],
          status: [{
            type:'number',
            message: '请选择当前状态',
            trigger: 'blur'
          }],
          maintain_time: [{
            message: '请选择计划维保时间',
            trigger: 'blur'
          }],
          remark: [{
            // required: true,
            message: '请填写备注',
            trigger: 'blur'
          }],
        },
        mainrules: {
          maintain_name: [{
            message: '请填写维保人',
            trigger: 'blur'
          }],
          finish_time: [{
            message: '请选择维保完成时间',
            trigger: 'blur'
          }],
          accept_person: [{
            message: '请填写验收人',
            trigger: 'blur'
          }],
          remark: [{
            message: '请填写备注',
            trigger: 'blur'
          }],
        },

        tableHeight: 900,
        searchFields: {
          KeyWord: ""
        },
        columns: [{
            field: "name",
            title: "设备设施名称",
            type: "string",
            width:240,
            align:'left'
          },
          {
            field: "discover_time",
            title: "发现时间",
            type: "string",
            width: 180,
            align: "center"
          },
          {
            field: "maintain_time",
            title: "计划维保时间",
            type: "string",
            width: 180,
            align: "center"

          },
          {
            field: "discover_person",
            title: "发现人",
            type: "string",
            width: 120,
            align: "center"
          },
          {
            field: "defect_type",
            title: "缺陷类型",
            type: "defect_type",
            width: 120,
            align: "center"
          },
          {
            field: "created_at",
            title: "创建时间",
            type: "string",
            width: 180,
            align: "center"
          },
          {
            field: "admin",
            title: "创建人",
            type: "format",
            width: 120,
            align: "center"
          },
          {
            field: "department",
            title: "创建人科室",
            type: "format",
            width: 120,
            align: "center"
          },
          {
            field: "操作",
            title: "操作",
            type: "opt",
            width: 220,
            fixed:'right'
          }
        ],
        uploadOther: {
          token: ""
        },
        deptOptions: []
      }
    },
    created() {
      this.uploadOther.token = getToken();
      this.initLoad();
      this.load();

    },
    methods: {
      initLoad() {
        var that = this;
        var clientHeight = document.documentElement.clientHeight
        var lxHeader_height = 96.5; //查询 头部
        var paginationHeight = 37; //分页的高度
        var topHeight = 50; //页面 头部
        let tableHeight = clientHeight - lxHeader_height - topHeight - paginationHeight - 20;
        that.tableHeight = tableHeight;
        //加载自定义参数
        getparameteritem("defectType").then(res => {
          this.parameters.defectType = res.detail;
        });
        //加载自定义参数
        getparameteritem("equipmentStatus").then(res => {
          this.parameters.equipmentStatus = res.detail;
        });
      },
      handleCurrentChange(page) {
        this.paginations.page = page;
        this.load();
      },
      load() {
        listtask({
          page: this.paginations.page,
          page_size: this.paginations.page_size,
          keyword:this.searchFields.KeyWord
        }).then(response => {
          this.tableData = response.data;
          this.paginations.total = response.total;
        }).catch(error => {
          console.log(error)
          reject(error)
        })

      },
      del(obj) {
        var that = this;
        if (obj) {
          this.$Modal.confirm({
            title: '确认要删除数据？',
            onOk: () => {
              del(obj.id).then(response => {
                this.$Message.success('操作成功');
                that.load();
              }).catch(error => {
                console.log(error)
                reject(error)
              })
            },
            onCancel: () => {
              //this.$Message.info('Clicked cancel');
            }
          });
        }
      },
      info(obj) {
        var that = this;
        get(obj.id).then(res => {
          let result = Object.assign(that.form, res);
          that.form = result;
          let _files = [];
          for (var mod of result.equipment_files) {
            let m = Object.assign({}, mod["files"]);
            m.name = mod["files"].original_name;
            _files.push(m);
          }
          that.fileList = _files;
          that.mainForm = result.maintains;
        }).catch(error => {
          //reject(error)
        })
      },
      edit(obj) {
        this.form = this.$options.data().form;
        this.clientHeight = document.documentElement.clientHeight - 84 - 110;
        if (obj) {
          var that = this;
          that.info(obj);
        } else {}
        this.dialogFormVisible = true;
      },
      editMain(obj) {
        this.form = this.$options.data().form;
        this.clientHeight = document.documentElement.clientHeight - 84 - 110;
        if (obj) {
          var that = this;
          that.info(obj);
        } else {}
        this.dialogMainFormVisible = true;
      },
      submitForm(formName) {
        var that = this;
        this.$refs[formName].validate((valid) => {
          if (valid) {
            if (that.form.id) {
              that.form.id = that.form.id;
              save(that.form).then(response => {
                //console.log(response)
                this.$Message.success('操作成功');
                that.load();
                that.dialogFormVisible = false;

              }).catch(error => {
                //reject(error)
              })
            } else {
              store(that.form).then(response => {
                //console.log(response)
                this.$Message.success('操作成功');
                that.load();
                that.dialogFormVisible = false;
              }).catch(error => {
                //reject(error)
              })
            }
            that.fileList = [];
          } else {
            this.$Message.error('数据校验失败');
            console.log('error submit!!');
            return false;
          }
        });
      },
      submitMainForm(formName) {
        var that = this;
        this.$refs[formName].validate((valid) => {
          if (valid) {
            if (that.form.id) {
                that.mainForm.id = that.form.id;
                maintains(that.mainForm).then(response => {
                  //console.log(response)
                  this.$Message.success('操作成功');
                  that.load();
                  that.dialogMainFormVisible = false;
                }).catch(error => {
                  //reject(error)
                })
            }
          } else {
            this.$Message.error('数据校验失败');
            console.log('error submit!!');
            return false;
          }
        });
      },
      handleRemove(file, fileList) {
        let listUrl = [];
        for (var m of fileList) {
          if (m.response)
            listUrl.push({"upload_id":m.response.id});
          else
            listUrl.push({"upload_id":m.id});
        }
        this.form.file_list = listUrl;
      },
      handleExceed(files, fileList) {},
      beforeRemove(file, fileList) {
        return this.$confirm(`确定移除 ${ file.name }？`);
      },
      handlesuccess(response, file, fileList) {
        let listUrl = [];
        for (var m of fileList) {
          if (m.response)
            listUrl.push({"upload_id":m.response.id});
          else
            listUrl.push({"upload_id":m.id});

        }
        this.form.file_list = listUrl;
      },
      resetForm(formName) {
        var that = this;
        that.fileList = [];
        this.$refs[formName].resetFields();
        that.dialogFormVisible = false;
        that.dialogMainFormVisible = false;
      },
    }
  }
</script>

<style>
  .dialogConcent {
    overflow-y: auto;
  }
</style>
